#include <iostream>
#include <functional>
#include <algorithm>
#include <vector>
#include <numeric>
#include <utility>
#include <cmath>

#define WATCH(x) std::cout << (#x) << ": " << x << '\n';
#define xx(container, lambda) container.begin(), container.end(), lambda

struct Pair
{
	int x;
	int y;
};

struct Input
{
	std::vector<Pair> points; 
};

Input read_input(int n)
{
	Input in;
	in.points.reserve(n);
	int x;
	int y;
	for (int i = 0; i < n; i++)
	{
		std::cin >> x >> y;
		in.points.push_back({x, y});
	}
	return in;
}

int distance(Pair x, Pair y)
{
	return std::abs(y.x - x.x) + std::abs(y.y - x.y);
}


BFS(std::vector<Pair> in.points)
{
	tt visited(in.points.size(), false);

	std::queue<Pair> q;
	q.push(in.points[0]);

	while (!q.empty())
	{
		Pair current = q.front();
			

		for (
	}

}


std::string solve(Input in)
{
	int acc = 0;
	std::sort(xx(in.points, [](Pair x, Pair y) { return x.x < y.x; }));
	
	BFS(in.points);

	Pair prev = in.points[0];
	for (int i = 0; i < in.points.size(); i++)
	{
		auto tmp = in.points[i];
		acc += distance(prev, in.points[i]);
		WATCH(tmp.x)
		WATCH(tmp.y)
		WATCH(acc)
		prev = in.points[i];
	}
	return std::to_string(acc);
}

int main()
{
	int n;
	std::cin >> n;
	auto in = read_input(n);

	std::cout << solve(in) << '\n'; 

	return 0;
}


